0 / 0 / 0
Регистрация: 06.09.2023
Сообщений: 4
1
SQLite

При добавлении пользователя выходит ошибка Cannot invoke "java.sql.Connection.prepareStatement(String)" because "this.co

11.09.2023, 16:21. Показов 625. Ответов 2

Author24 — интернет-сервис помощи студентам
Приветствую, делаю бд sqlite и при добавлении пользователя выходит ошибка Cannot invoke "java.sql.Connection.prepareStatement(String)" because "this.connection" is null

Java
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
public class DataBaseHandler extends Const {
 
    private static final String DB_URL = "jdbc:sqlite:../db.db";
 
    private Connection connection;
 
    public DataBaseHandler() {
        try {
            // Загрузка драйвера JDBC для SQLite
            Class.forName("org.sqlite.JDBC");
        } catch (ClassNotFoundException e) {
            System.err.println("Не удалось загрузить драйвер JDBC");
            e.printStackTrace();
        }
    }
 
    public void connect() {
        try {
            // Подключение к базе данных
            connection = DriverManager.getConnection(DB_URL);
            System.out.println("Подключение к базе данных выполнено успешно!");
        } catch (SQLException e) {
            System.err.println("Не удалось подключиться к базе данных");
            e.printStackTrace();
        }
    }
 
    public void disconnect() {
        try {
            if (connection != null && !connection.isClosed()) {
                // Закрытие подключения
                connection.close();
                System.out.println("Отключение от базы данных выполнено успешно!");
            }
        } catch (SQLException e) {
            System.err.println("Не удалось отключиться от базы данных");
            e.printStackTrace();
        }
    }
 
    public Connection getConnection() {
        return connection;
    }
 
    public void addUser(String nikname, String login, String password) {
        String sql = "INSERT  INTO users (nikname, login, password) VALUES (?, ?, ?)";
        try (PreparedStatement statement = connection.prepareStatement(sql)) {
                statement.setString(1, nikname);
                statement.setString(2, login);
                statement.setString(3, password);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }
}
0
Programming
Эксперт
94731 / 64177 / 26122
Регистрация: 12.04.2006
Сообщений: 116,782
11.09.2023, 16:21
Ответы с готовыми решениями:

При добавлении записи выходит ошибка
При добавлении записи выходит ошибка. Необработанное исключение типа...

При добавлении сессии в файл выходит ошибка
Что в этом коде не так ? Доблаяю сессию чтобы пользователь долго был активен на сайте, но выходит...

При добавлении utm-меток выходит ошибка 404
Собственно сабж, при добавлении utm-меток выходит ошибка 404. Если добавить в конец ?test, то все...

Правила обновления SQL: не работает обновление при добавлении нового пользователя
Форумчане) Проблема одна с обновлением при добавлении нового пользователя)

При нажатии на кнопку выходит ошибка "Attempting to invoke method on a null object reference"
Доброго дня! Есть вот этот код. При нажатии на кнопку Add выдает Attempting to invoke interface...

2
Am I evil? Yes, I am!
Эксперт PythonЭксперт Java
17564 / 10318 / 2819
Регистрация: 21.10.2017
Сообщений: 22,374
11.09.2023, 19:33 2
Ну хз. Арбайтен
Java
1
2
3
4
5
6
7
8
9
10
package ru.ismokejc;
 
public class Cyber {
    public static void main(String[] args) {
        DataBaseHandler handler = new DataBaseHandler();
        handler.connect();
        handler.addUser("user", "user", "password");
        handler.disconnect();
    }
}
Java
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
package ru.ismokejc;
 
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
 
public class DataBaseHandler {
    private static final String DB_URL = "jdbc:sqlite:db.db";
 
    private Connection connection;
 
    public DataBaseHandler() {
        try {
//             Загрузка драйвера JDBC для SQLite
            Class.forName("org.sqlite.JDBC");
        } catch (ClassNotFoundException e) {
            System.err.println("Не удалось загрузить драйвер JDBC");
            e.printStackTrace();
        }
    }
 
    public void connect() {
        try {
            // Подключение к базе данных
            connection = DriverManager.getConnection(DB_URL);
            System.out.println("Подключение к базе данных выполнено успешно!");
            connection.setAutoCommit(false);
        } catch (SQLException e) {
            System.err.println("Не удалось подключиться к базе данных");
            e.printStackTrace();
        }
    }
 
    public void disconnect() {
        try {
            if (connection != null && !connection.isClosed()) {
                // Закрытие подключения
                connection.close();
                System.out.println("Отключение от базы данных выполнено успешно!");
            }
        } catch (SQLException e) {
            System.err.println("Не удалось отключиться от базы данных");
            e.printStackTrace();
        }
    }
 
    public void addUser(String nikname, String login, String password) {
        String sql = "INSERT  INTO users (nikname, login, password) VALUES (?, ?, ?)";
        try (PreparedStatement statement = connection.prepareStatement(sql)) {
            statement.setString(1, nikname);
            statement.setString(2, login);
            statement.setString(3, password);
            statement.executeUpdate();
            connection.commit();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }
    }
}
При добавлении пользователя выходит ошибка Cannot invoke "java.sql.Connection.prepareStatement(String)" because "this.co
1
0 / 0 / 0
Регистрация: 06.09.2023
Сообщений: 4
12.09.2023, 03:46  [ТС] 3
спасибо, без тебя я наверное еще сидел бы и не замечал, что я забыл к бд приконектится, это меня скоро доведет
0
12.09.2023, 03:46
IT_Exp
Эксперт
87844 / 49110 / 22898
Регистрация: 17.06.2006
Сообщений: 92,604
12.09.2023, 03:46
Помогаю со студенческими работами здесь

Ошибка при добавлении базы данных (при коннектинге "Add Connection")
Здравствуйте, возникла проблема при коннектинге базы данных. После того как хочу создать новую базу...

ошибка при создании приложения Exception in thread "main" java.lang.NullPointerException: Cannot invoke "java.net.URL.to
Ошибка: C:\Users\kozna\.jdks\openjdk-16\bin\java.exe "-javaagent:D:\IntelliJ IDEA Community...

Ошибка при добавлении пользователя в базу данных
ОШИБКА: столбец "updated_at" в таблице "users" не существует. Laravel 8.83.26 База данных: ...

Ошибка при добавлении локального пользователя через групповую политику
Контроллер домена 2008R2 Клиент Win11, Win10 Для OU, в который помещены компьютеры...

При подключении к SQL выходит ошибка
Когда в свойстве ConnectionString ADOConnection нажимаю Build делфи выдает ошибку: "Класс не...


Искать еще темы с ответами

Или воспользуйтесь поиском по форуму:
3
Ответ Создать тему
Опции темы

КиберФорум - форум программистов, компьютерный форум, программирование
Powered by vBulletin
Copyright ©2000 - 2024, CyberForum.ru